var $ = document;

let locationParameter = new URLSearchParams(location.search);
let mainUsernameId = locationParameter.get("username");

const productsContainer = $.getElementById("product-container");
const sumPrice = $.getElementById("sum-price");
const finallyBasket = $.getElementById("final-basket-buy");
let orderNumber = null;
let basketArray = [];
const regOrLogSpan = $.getElementById("register-or-log-span");

window.addEventListener("load", () => {
  fetch(
    `https://prj-un-default-rtdb.europe-west1.firebasedatabase.app/users/${mainUsernameId}/basket.json`
  )
    .then((res) => res.json())
    .then((data) => {
      let productsObject = Object.entries(data);
      productsObject.forEach((product) => {
        basketArray.push(product[1]);
      });
      basketElementGenerator(basketArray);
      calcBasket(basketArray);
    });
});
finallyBasket.addEventListener("click", () => {
  if (basketArray) {
    fetch(
      `https://prj-un-default-rtdb.europe-west1.firebasedatabase.app/users/${mainUsernameId}/basket.json`,
      {
        method: "PUT",
        headers: {
          "content-type": "application/json",
        },
        body: JSON.stringify(basketArray),
      }
    ).then((res) => {
      console.log(res);
      let success = res.status;
      if (success == 200) {
        console.log("buy is success");
      }
    });
    orderNumber = Math.floor(Math.random() * 10000);
    fetch(
      `https://prj-un-default-rtdb.europe-west1.firebasedatabase.app/order/${mainUsernameId}/${orderNumber}.json`,
      {
        method: "POST",
        headers: {
          "content-type": "application/json",
        },
        body: JSON.stringify(basketArray),
      }
    ).then((res) => {
      console.log(res);
      location.href = `./payment.html?username=${mainUsernameId}&basket=${orderNumber}`;
    });
    fetch(
      `https://prj-un-default-rtdb.europe-west1.firebasedatabase.app/users/${mainUsernameId}/orders/${orderNumber}.json`,
      {
        method: "PUT",
        headers: {
          "content-type": "application/json",
        },
        body: JSON.stringify(basketArray),
      }
    );
  }
});

const calcBasket = (basket) => {
  let sumBasket = 0;
  basket.forEach((product) => {
    sumBasket = sumBasket + product.minBon * product.count * 1000;
  });
  sumPrice.innerHTML = sumBasket;
};
const deleteFromBasket = (productId) => {
  basketArray = basketArray.filter(function (product) {
    return product.id !== productId;
  });
  basketElementGenerator(basketArray);
  calcBasket(basketArray);
};
const basketElementGenerator = (basket) => {
  productsContainer.innerHTML = "";
  basket.forEach(function (product) {
    productsContainer.insertAdjacentHTML(
      "beforeend",
      `
            <tr class="grid gap-x-4 grid-cols-5 text-center items-center my-3 rounded-md">
                <td><img class="w-16 mx-auto" src="${product.img}" alt=""></td>
                <td><span>${product.title}</span></td>
                <td><input onchange="addOrMinProduct(${product.id},this.value)" class="bg-gray-100 rounded-lg  text-center outline-none " type="number" value="${product.count}" name="" max="10" min="1" id=""></td>
                <td><span>${product.minBon}</span></td>
                <td><img onclick="deleteFromBasket(${product.id})" class="w-8 mx-auto cursor-pointer" src="./img/delete.svg" alt=""></td>
            </tr>
        `
    );
  });
};
const addOrMinProduct = (productId, newCount) => {
  basketArray.find((product) => {
    if (productId === product.id) {
      product.count = newCount;
    }
  });
  calcBasket(basketArray);
};
regOrLogSpan.addEventListener("click", () => {
  if (mainUsernameId) {
    location.href = `./profile.html?username=${mainUsernameId}`;
  } else {
    location.href = `./login.html`;
  }
});
if (mainUsernameId) {
  window.addEventListener("load", () => {
    fetch(
      `https://prj-un-default-rtdb.europe-west1.firebasedatabase.app/users.json`
    )
      .then((res) => res.json())
      .then((data) => {
        let usersObject = Object.entries(data);
        let loginnedUser = usersObject.find((user) => {
          return user[0] === mainUsernameId;
        });
        regOrLogSpan.innerHTML = loginnedUser[1].name;
      });
  });
}
