var $ = document

let allProducts = []
window.addEventListener('load',()=>{
    fetch(`https://prj-un-default-rtdb.europe-west1.firebasedatabase.app/products.json`)
        .then(res => res.json())
        .then(data => {
            let products = Object.entries(data)
            products.forEach((product)=>{
             allProducts.push(product[1])
            })   
        })
        setTimeout(()=>{
            productDisplay(allProducts)
        },3000)
    })
const productDisplay = (allProduct)=> {
    allProduct.forEach((product) => {
        const productHTML = `
                <div class="flex flex-col hover:scale-105 text-center pb-6 bg-white border rounded-xl mx-3 my-5 swiper-slide hover:shadow-red-500 hover:shadow-sm hover:duration-500 hover:ease-in-out">
                    <a href="/public/single-product.html?id=${product.id}">
                        <img class="rounded-xl p-5 hover:scale-105 duration-300 ease-in-out" src="${product.img}" alt="">
                    </a>
                    <span>${product.title}</span>
                    <span class="font-anjoman-medium">بن پایه: ${product.minBon}</span>
                    <button onClick="addToCard(${product.id})" id="add-to-card" class="bg-purple-500 p-2 rounded-lg text-white text-xs mt-2 hover:shadow-lg hover:ease-in font-anjoman-medium">شرکت در قرعه کشی</button>
                </div>
            `
        productSliderOne.insertAdjacentHTML("beforeend", productHTML)
        productSliderTwo.insertAdjacentHTML("beforeend", productHTML)
        productSliderThree.insertAdjacentHTML("beforeend", productHTML)
        redBigSlider.insertAdjacentHTML("beforeend", productHTML)

    })
}


let userBasket = []
let basketArray = []

const showBasketBtn = $.getElementById("showBasket")
const basketModal = $.getElementById("basket-modal")
const basketContainer = $.getElementById("basket-container")
const sumPrice = $.getElementById("sum-price")
const postTobasket = $.getElementById('post-to-basket')

const productSliderOne = $.getElementById("slider-one")
const productSliderTwo = $.getElementById("sliderTwo")
const productSliderThree = $.getElementById("sliderThree")
const redBigSlider = $.getElementById("red-big-slider")

let locationParameter = new URLSearchParams(location.search)
let mainUsernameId = locationParameter.get('username')

const regOrLogBtn = $.getElementById('reg-or-log-btn')
const regOrLogSpan = $.getElementById('register-or-log-span')

const firstRegisterOrLogin = $.getElementById('first-register-or-login')
const closefirstRegisterOrLogin = $.getElementById('close-first-register-or-login')

closefirstRegisterOrLogin.addEventListener('click',()=>{
    firstRegisterOrLogin.classList.add('hidden')
})



const basketElementGenerator = (basket)=>{
    basketContainer.innerHTML = ''
    basket.forEach(function(product){
        basketContainer.insertAdjacentHTML('afterbegin',`<div class="flex justify-center items-center my-3">
        <div class="mx-3 "><img class="rounded-md" src="${product.img}" alt=""></div>
        <div class="mx-3 "><span>${product.title}</span></div>
        <div class="mx-3 "><span>${product.minBon}</span></div>
        <div class="mx-3 "><input id="count-product" onchange="addOrMinProduct(${product.id},this.value)" class="outline-none rounded-2xl text-center" value="${product.count}" type="number" min="1" max="10" name="" id=""></div>
        <div class="cursor-pointer "><img onclick="deleteFromBasket(${product.id})" class="w-28" src="./img/delete.svg" alt=""></div>
    </div>`)
    })

}
// delete product from basket function
const deleteFromBasket = (productId)=>{
    basketArray = basketArray.filter(function(product){
        return product.id !== productId
    })
    basketElementGenerator(basketArray)
    calcBasket(basketArray)
    
}
// calcute basket function
const calcBasket = (basket)=>{
    let sumBasket = 0
    basket.forEach((product)=>{
        sumBasket = sumBasket + (product.minBon * product.count) *1000
    })
    sumPrice.innerHTML = sumBasket
}
//toggle show basket 
showBasketBtn.addEventListener('click',()=>{
    basketModal.classList.toggle("hidden")
})
//add or mines product from basket
const addOrMinProduct = (productId,newCount)=>{
    basketArray.find((product)=>{
        if(productId === product.id){
            product.count = newCount
        }
    })
    calcBasket(basketArray)
}

if(mainUsernameId){
    window.addEventListener('load',()=>{
        fetch(`https://prj-un-default-rtdb.europe-west1.firebasedatabase.app/users.json`)
            .then(res => res.json())
            .then(data => {
                let usersObject = Object.entries(data)
                let loginnedUser = usersObject.find((user)=>{
                    return user[0] === mainUsernameId
                })
                regOrLogSpan.innerHTML = loginnedUser[1].name
            })
    })
}

const addToCard = (productId)=>{
    if(mainUsernameId){
        basketContainer.innerHTML = ''
        let ifIn = basketArray.some((product)=>{
            return product.id === productId
        })
        if(ifIn){
            basketArray.find((product)=>{
                if(product.id === productId){
                    product.count += 1
                    basketElementGenerator(basketArray)
                    calcBasket(basketArray)
                }
            })
        }else{
            let mainProduct = allProducts.find((product)=>{
                return product.id === productId
            })
            basketArray.push(mainProduct)
            basketElementGenerator(basketArray)
            calcBasket(basketArray)
        }
    }else{
        firstRegisterOrLogin.classList.remove('hidden')
        
    }
    
}

postTobasket.addEventListener('click',()=>{
    if(basketArray){
        fetch(`https://prj-un-default-rtdb.europe-west1.firebasedatabase.app/users/${mainUsernameId}/basket.json`, {
            method: 'PUT',
            headers: {
                'content-type' : 'application/json'
            },
            body: JSON.stringify(basketArray)
        })
        .then(res => {
            console.log(res)
            let success = res.status
            if(success == 200){
                location.href = `./basket.html?username=${mainUsernameId}`
            }
        })
    }
})

regOrLogBtn.addEventListener('click',()=>{
    if(mainUsernameId){
        location.href = `./profile.html?username=${mainUsernameId}`
    }else{
        location.href = `./login.html`
    }
})


var allProducts2 = [
    {id: 1,title:"RAM",minBon:50, sold:0,img:"../public/productSlider/1.jpg",totalChance:100,count:1},
    {id: 2,title:"Hard Disk",minBon:70, sold:0,img:"../public/productSlider/2.jpg",totalChance:140,count:1},
    {id: 3,title:"CPU",minBon:90, sold:0,img:"../public/productSlider/3.jpg",totalChance:180,count:1},
    {id: 4,title:"مانیتور",minBon:80, sold:0,img:"../public/productSlider/4.jpg",totalChance:160,count:1},
    {id: 5,title:"کیس",minBon:30, sold:0,img:"../public/productSlider/5.jpg",totalChance:60,count:1},
    {id: 6,title:"ماوس",minBon:10, sold:0,img:"../public/productSlider/6.jpg",totalChance:20,count:1},
    {id: 7,title:"لپ تاب",minBon:200, sold:0,img:"../public/productSlider/7.jpg",totalChance:400,count:1},
    {id: 8,title:"کیبورد",minBon:20, sold:0,img:"../public/productSlider/8.jpg",totalChance:40,count:1},
    {id: 9,title:"PS4",minBon:100, sold:0,img:"../public/productSlider/9.jpg",totalChance:200,count:1},
    {id: 10,title:"پاوربانک",minBon:10, sold:0,img:"../public/productSlider/10.jpg",totalChance:30,count:1}
]
window.addEventListener('load', ()=>{
    fetch(`https://prj-un-default-rtdb.europe-west1.firebasedatabase.app/products.json`, {
        method: 'PUT', 
        headers: {
            'content-type' : 'application/json'
        },
        body: JSON.stringify(allProducts2)

    })
})
