let $ = document

const registerForm = $.getElementById("register-form")
const loginForm = $.getElementById("login-form")
const toggleLogin = $.getElementById("login-toggle")
const toggleregister = $.getElementById("register-toggle")
// تاگل در تغییر محتوای لاگین و ثبت نام
toggleregister.addEventListener('click',()=>{
    registerForm.classList.remove("hidden")
    loginForm.classList.add("hidden")
})

toggleLogin.addEventListener('click',()=>{
    registerForm.classList.add("hidden")
    loginForm.classList.remove("hidden")
})
// صحت سنجی ایمیل با رجکس
const emailRegEx = /[a-zA-Z1-9]+@gmail.com/g
//بخش دریافت ورودی ها

const registerEmailInput = $.getElementById("register-email-input")
const registerNameInput = $.getElementById("register-name-input")
const registerPasswordInput = $.getElementById("register-password-input")
const registerPhoneInput = $.getElementById("register-phone-input")
const registerAddressInput = $.getElementById("register-address-input")
const registerBtnSubmit = $.getElementById("btn-register")
const emailFalsElem = $.getElementById("email-fals-register")
const loginEmailInput = $.getElementById("login-email-input")
const loginBtnSubmit = $.getElementById("btn-login")
const loginPasswordInput = $.getElementById("login-password-input")
// ارور های اشتباه بودن رمز عبور و ایمیل
const emailFalsLogin = $.getElementById("email-fals")
const passwordFalsLogin = $.getElementById("pass-fals")
//درستی ثبت نام
const successRegister = $.getElementById("success-register")

console.log(registerBtnSubmit);
const saltRounds = 10;




registerBtnSubmit.addEventListener('click',async (event)=>{
    event.preventDefault()
    const passwordHash = await hashPassword(registerPasswordInput.value);
    
    let userData = {
        name : registerNameInput.value,
        phone : registerPhoneInput.value,
        address : registerAddressInput.value,
        email : registerEmailInput.value,
        password : passwordHash,
        bon:0
    }
    let emailTest = emailRegEx.test(userData.email)
    if(emailTest){
        //POST TO FIRBASE
        fetch('https://prj-un-default-rtdb.europe-west1.firebasedatabase.app/users.json', {
            method: 'POST',
            headers: {
                'content-type' : 'application/json'
            },
            body: JSON.stringify(userData)
        })
        .then(res => {
            console.log(res)
            let success = res.status
            if(success == 200){
                successRegister.classList.remove('hidden')
            }
        })
        .catch(err => console.log(err))
        emptyInputes()
        
        
        
    }else {
        emailFalsElem.classList.remove('hidden')
    } 
})
async function hashPassword(password) {
    const encoder = new TextEncoder();
    const data = encoder.encode(password);
    const hashBuffer = await crypto.subtle.digest('SHA-256', data);
    return bufferToHex(hashBuffer);
}

function bufferToHex(buffer) {
    const hexCodes = [];
    const view = new DataView(buffer);
    for (let i = 0; i < view.byteLength; i += 4) {
        const value = view.getUint32(i);
        const stringValue = value.toString(16);
        const paddedValue = ('00000000' + stringValue).slice(-8);
        hexCodes.push(paddedValue);
    }
    return hexCodes.join('');
}
const emptyInputes = ()=>{
    registerAddressInput.value = ''
    registerEmailInput.value = ''
    registerNameInput.value = ''
    registerPasswordInput.value = ''
    registerPhoneInput.value = ''
}

let islogin = false
let userIdIfLogin = null
loginBtnSubmit.addEventListener('click',(e)=>{
    e.preventDefault()
    fetch('https://prj-un-default-rtdb.europe-west1.firebasedatabase.app/users.json')
        .then(res => res.json())
        .then(async data => {
            let usersObj = Object.entries(data)
            let loginUser = usersObj.find((user)=>{
                return user[1].email === loginEmailInput.value
            })
            if(loginUser){
                const passwordHash = await hashPassword(loginPasswordInput.value);
                if(passwordHash === loginUser[1].password){
                    location.href = `./profile.html?username=${loginUser[0]}`
                    islogin = true
                    userIdIfLogin = loginUser[0]
                    console.log(userIdIfLogin);
                }else{
                    passwordFalsLogin.classList.remove("hidden")
                }
            }else{
                emailFalsElem.classList.remove("hidden")
            }
        })
    
})