var $ = document

var allProducts = [
    {id: 1,title:"RAM",minBon:50, sold:0,img:"../public/productSlider/1.jpg",totalChance:0},
    {id: 2,title:"Hard Disk",minBon:70, sold:0,img:"../public/productSlider/2.jpg",totalChance:0},
    {id: 3,title:"CPU",minBon:90, sold:0,img:"../public/productSlider/3.jpg",totalChance:0},
    {id: 4,title:"مانیتور",minBon:80, sold:0,img:"../public/productSlider/4.jpg",totalChance:0},
    {id: 5,title:"کیس",minBon:30, sold:0,img:"../public/productSlider/5.jpg",totalChance:0},
    {id: 6,title:"ماوس",minBon:10, sold:0,img:"../public/productSlider/6.jpg",totalChance:0},
    {id: 7,title:"لپ تاب",minBon:200, sold:0,img:"../public/productSlider/7.jpg",totalChance:0},
    {id: 8,title:"کیبورد",minBon:20, sold:0,img:"../public/productSlider/8.jpg",totalChance:0},
    {id: 9,title:"PS4",minBon:100, sold:0,img:"../public/productSlider/9.jpg",totalChance:0},
    {id: 10,title:"پاوربانک",minBon:10, sold:0,img:"../public/productSlider/10.jpg",totalChance:0}
]

const productContainer = $.getElementById("product-container")

let locationParams = new URLSearchParams(location.search)
let mainProductId = locationParams.get('id')

let mainProduct = allProducts.find((product)=>{
    return product.id === Number(mainProductId)
})
console.log(mainProduct);
productContainer.insertAdjacentHTML('beforeend',`<div class="pt-8 mr-14 font-anjoman-bold">
    <h2>${mainProduct.title}</h2>
    </div>
    <div class="flex justify-around mt-8">
    <div>
        <img src="${mainProduct.img}" alt="">
    </div>
    <div>
        <ul>
            <h2 class="font-anjoman-bold">مشخصات</h2>
            <li>AM 32x new design</li>
            <li>Android</li>
            <li>A2C</li>
            <li>64</li>
            <li>32</li>
        </ul>
    </div>
    <div class="shadow-lg bg-gray-50 w-1/4 h-1/2 p-5 border rounded-2xl flex flex-col justify-center items-center" >
        <div class="w-3/4 my-4 flex justify-between mx-5">
            <span>گارانتی:</span>
            <span>6 ماهه تمام</span>
        </div>
        <div class="w-3/4 my-4 flex justify-between mx-5">
            <span>قیمت:</span>
            <span>${mainProduct.price}</span>
        </div>
        <div class="w-3/4 my-4 flex justify-between mx-5">
            <span>تعداد:</span>
            <input class="rounded-md outline-none text-center" value="${mainProduct.count}" type="number" name="" min="1" max="10" id="">
        </div>
        <div>
            <button onClick="addToCard(${mainProduct.id})" class="bg-red-500 text-white py-2 px-3 rounded-lg shadow-lg mx-auto">افزودن به سبد خرید</button>
        </div>
    </div>
    </div>`)
//add too card in product page
let userBasket = []
let basketArray = []

const showBasketBtn = $.getElementById("showBasket")
const basketModal = $.getElementById("basket-modal")
const basketContainer = $.getElementById("basket-container")
const sumPrice = $.getElementById("sum-price")



const addToCard = (productId)=>{
    basketContainer.innerHTML = ''
    let mainProduct = allProducts.find(function(product){
        return product.id === productId
    });
    basketArray.push(mainProduct)
    basketElementGenerator(basketArray)
    calcBasket(basketArray)
}

const basketElementGenerator = (basket)=>{
    basketContainer.innerHTML = ''
    basket.forEach(function(product){
        basketContainer.insertAdjacentHTML('afterbegin',`<div class="flex justify-center items-center my-3">
        <div class="mx-3 "><img class="rounded-md" src="${product.img}" alt=""></div>
        <div class="mx-3 "><span>${product.title}</span></div>
        <div class="mx-3 "><span>${product.price}</span></div>
        <div class="mx-3 "><input id="count-product" onchange="addOrMinProduct(${product.id},this.value)" class="outline-none rounded-2xl text-center" value="${product.count}" type="number" min="1" max="10" name="" id=""></div>
        <div class="cursor-pointer "><img onclick="deleteFromBasket(${product.id})" class="w-28" src="./img/delete.svg" alt=""></div>
    </div>`)
    })

}
// delete product from basket function
const deleteFromBasket = (productId)=>{
    basketArray = basketArray.filter(function(product){
        return product.id !== productId
    })
    basketElementGenerator(basketArray)
    calcBasket(basketArray)
    
}
// calcute basket function
const calcBasket = (basket)=>{
    let sumBasket = 0
    basket.forEach((product)=>{
        sumBasket = sumBasket + (product.price * product.count)
    })
    sumPrice.innerHTML = sumBasket
}
//toggle show basket 
showBasketBtn.addEventListener('click',()=>{
    basketModal.classList.toggle("hidden")
})
//add or mines product from basket
const addOrMinProduct = (productId,newCount)=>{
    basketArray.find((product)=>{
        if(productId === product.id){
            product.count = newCount
        }
    })
    calcBasket(basketArray)
}